## cdist 4.0.0~pre3

=== Makefile ===
#
# 2013 Nico Schottelius (nico-cdist at schottelius.org)
#
# This file is part of cdist.
#
# cdist is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# cdist is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with cdist. If not, see <http://www.gnu.org/licenses/>.
#
#

A2XM=a2x -f manpage --no-xmllint -a encoding=UTF-8
A2XH=a2x -f xhtml --no-xmllint -a encoding=UTF-8
# Create cross-links in html man pages
# We look for something like "cdist-type(7)" and make a href out of it
# The first matching group is the man page name and the second group
# is the man page section (1 or 7). The first three lines of the input
# (xml, DOCTYPE, head tags) are ignored, since the head tags contains
# the title of the page and should not contain a href.
CROSSLINK=sed --in-place '1,3!s/\([[:alnum:]_-]*\)(\([17]\))/<a href="..\/man\2\/\1.html">&<\/a>/g'
helper=./bin/build-helper

MANDIR=docs/man
SPEECHDIR=docs/speeches
TYPEDIR=cdist/conf/type

WEBSRCDIR=docs/web

WEBDIR=$$HOME/www.nico.schottelius.org
WEBBLOG=$(WEBDIR)/blog
WEBBASE=$(WEBDIR)/software/cdist
WEBPAGE=$(WEBBASE).mdwn

CHANGELOG_VERSION=$(shell $(helper) changelog-version)
CHANGELOG_FILE=docs/changelog

PYTHON_VERSION=cdist/version.py

################################################################################
# Manpages
#
MAN1DSTDIR=$(MANDIR)/man1
MAN7DSTDIR=$(MANDIR)/man7

# Manpages #1: Types
# Use shell / ls to get complete list - $(TYPEDIR)/*/man.text does not work
MANTYPESRC=$(shell ls $(TYPEDIR)/*/man.text)

# replace first path component
MANTYPEPREFIX=$(subst $(TYPEDIR)/,$(MAN7DSTDIR)/cdist-type,$(MANTYPESRC))

# replace man.text with .7 or .html
MANTYPEMAN=$(subst /man.text,.7,$(MANTYPEPREFIX))
MANTYPEHTML=$(subst /man.text,.html,$(MANTYPEPREFIX))
MANTYPEALL=$(MANTYPEMAN) $(MANTYPEHTML)

# Link manpage so A2XH does not create man.html but correct named file
$(MAN7DSTDIR)/cdist-type%.text: $(TYPEDIR)/%/man.text
	ln -sf "../../../$^" $@

# Manpages #2: reference
MANREF=$(MAN7DSTDIR)/cdist-reference.text
MANREFSH=$(MANDIR)/cdist-reference.text.sh
MANREFMAN=$(MANREF:.text=.7)
MANREFHTML=$(MANREF:.text=.html)
MANREFALL=$(MANREFMAN) $(MANREFHTML)

$(MANREF): $(MANREFSH)
	$(MANREFSH)

# Manpages #3: static pages
MAN1STATIC=$(shell ls $(MAN1DSTDIR)/*.text)
MAN7STATIC=$(shell ls $(MAN7DSTDIR)/*.text)
MANSTATICMAN=$(MAN1STATIC:.text=.1) $(MAN7STATIC:.text=.7)
MANSTATICHTML=$(MAN1STATIC:.text=.html) $(MAN7STATIC:.text=.html)
MANSTATICALL=$(MANSTATICMAN) $(MANSTATICHTML)

# Manpages #4: generic part

# Creating the type manpage
%.1 %.7: %.text
	$(A2XM) $^

# Creating the type html page
%.html: %.text
	$(A2XH) $^
	$(CROSSLINK) $@

man: $(MANTYPEALL) $(MANREFALL) $(MANSTATICALL)

# Manpages #5: release part
MANWEBDIR=$(WEBBASE)/man/$(CHANGELOG_VERSION)

man-dist: man check-date
	rm -rf "${MANWEBDIR}"
	mkdir -p "${MANWEBDIR}/man1" "${MANWEBDIR}/man7"
	cp ${MAN1DSTDIR}/*.html ${MAN1DSTDIR}/*.css ${MANWEBDIR}/man1
	cp ${MAN7DSTDIR}/*.html ${MAN7DSTDIR}/*.css ${MANWEBDIR}/man7
	cd ${MANWEBDIR} && git add . && git commit -m "cdist manpages update: $(CHANGELOG_VERSION)" || true

man-latest-link: web-pub
	# Fix ikiwiki, which does not like symlinks for pseudo security
	ssh tee.schottelius.org \
    	"cd /home/services/www/nico/www.nico.schottelius.org/www/software/cdist/man && rm -f latest && ln -sf "$(CHANGELOG_VERSION)" latest"

################################################################################
# Speeches
#
SPEECHESOURCES=$(SPEECHDIR)/*.tex
SPEECHES=$(SPEECHESOURCES:.tex=.pdf)
SPEECHESWEBDIR=$(WEBBASE)/speeches

# Create speeches and ensure Toc is up-to-date
$(SPEECHDIR)/%.pdf: $(SPEECHDIR)/%.tex
	pdflatex -output-directory $(SPEECHDIR) $^
	pdflatex -output-directory $(SPEECHDIR) $^
	pdflatex -output-directory $(SPEECHDIR) $^

speeches: $(SPEECHES)

speeches-dist: speeches
	rm -rf "${SPEECHESWEBDIR}"
	mkdir -p "${SPEECHESWEBDIR}"
	cp ${SPEECHES} "${SPEECHESWEBDIR}"
	cd ${SPEECHESWEBDIR} && git add . && git commit -m "cdist speeches updated" || true

################################################################################
# Website
#

BLOGFILE=$(WEBBLOG)/cdist-$(CHANGELOG_VERSION)-released.mdwn

$(BLOGFILE): $(CHANGELOG_FILE)
	$(helper) blog $(CHANGELOG_VERSION) $(BLOGFILE)

web-blog: $(BLOGFILE)

web-doc:
	# Go to top level, because of cdist.mdwn
	rsync -av "$(WEBSRCDIR)/" "${WEBBASE}/.."
	cd "${WEBBASE}/.." && git add cdist* && git commit -m "cdist doc update" cdist* || true

web-dist: web-blog web-doc

web-pub: web-dist man-dist speeches-dist
	cd "${WEBDIR}" && make pub

web-release-all: man-latest-link
web-release-all-no-latest: web-pub

################################################################################
# Release: Mailinglist
#
ML_FILE=.lock-ml

# Only send mail once - lock until new changelog things happened
$(ML_FILE): $(CHANGELOG_FILE)
	$(helper) ml-release $(CHANGELOG_VERSION)
	touch $@

ml-release: $(ML_FILE)


################################################################################
# Release: Freecode
#
FREECODE_FILE=.lock-freecode

$(FREECODE_FILE): $(CHANGELOG_FILE)
	$(helper) freecode-release $(CHANGELOG_VERSION)
	touch $@

freecode-release: $(FREECODE_FILE)

################################################################################
# pypi
#
PYPI_FILE=.pypi-release
$(PYPI_FILE): man $(PYTHON_VERSION)
	python3 setup.py sdist upload
	touch $@

pypi-release: $(PYPI_FILE)
################################################################################
# archlinux
#
ARCHLINUX_FILE=.lock-archlinux
ARCHLINUXTAR=cdist-$(CHANGELOG_VERSION)-1.src.tar.gz

$(ARCHLINUXTAR): PKGBUILD
	makepkg -c --source

PKGBUILD: PKGBUILD.in $(PYTHON_VERSION)
	./PKGBUILD.in $(CHANGELOG_VERSION)

$(ARCHLINUX_FILE): $(ARCHLINUXTAR) $(PYTHON_VERSION)
	burp -c system $(ARCHLINUXTAR)
	touch $@

archlinux-release: $(ARCHLINUX_FILE)

################################################################################
# Release
#

$(PYTHON_VERSION): .git/refs/heads/master
	$(helper) version

# Code that is better handled in a shell script
check-%:
	$(helper) $@

release:
	$(helper) $@

################################################################################
# Cleanup
#

clean:
	rm -f $(MAN7DSTDIR)/cdist-reference.text

	find "$(MANDIR)" -mindepth 2 -type l \
	    -o -name "*.1" \
	    -o -name "*.7" \
	    -o -name "*.html" \
	    -o -name "*.xml" \
	| xargs rm -f

	find * -name __pycache__  | xargs rm -rf

	# Archlinux
	rm -f cdist-*.pkg.tar.xz cdist-*.tar.gz
	rm -rf pkg/ src/

	rm -f MANIFEST PKGBUILD
	rm -rf dist/

distclean: clean
	rm -f cdist/version.py

################################################################################
# Misc
#

# The pub is Nico's "push to all git remotes" way ("make pub")
pub:
	for remote in "" github sf; do \
		echo "Pushing to $$remote"; \
		git push --mirror $$remote; \
	done

test:
	$(helper) $@

=== debian/changelog ===
cdist (4.0.0~pre3-2) unstable; urgency=medium

  * Bump standards version to 3.9.7 (no changes needed)
  * Do not hardcode python version dependency (Closes: #802784)
  * Replace insecure git:// uri in Vcs-Git field with secure https://
  * Fix spelling errors in manpages

 -- Dmitry Bogatov <KAction@gnu.org>  Wed, 06 Apr 2016 16:36:05 +0300

cdist (4.0.0~pre3-1) unstable; urgency=low

  * Initial release (Closes: #785334)
  * Add patch to enable build without git checkout
  * Add patch to fix manpages spelling errors

 -- Dmitry Bogatov <KAction@gnu.org>  Thu, 14 May 2015 05:08:03 +0300

=== debian/control ===
Source: cdist
Maintainer: Dmitry Bogatov <KAction@gnu.org>
Section: admin
Priority: optional
Build-Depends: debhelper (>= 9),
 asciidoc,
 dh-python,
 docbook-utils,
 libxml2-utils,
 python3,
 xmlto,
 xsltproc,
Standards-Version: 3.9.7
Homepage: http://www.nico.schottelius.org/software/cdist/
Vcs-Browser: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git
Vcs-Git: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git

Package: cdist
Architecture: all
Depends: python3 (>= 3.4), ${misc:Depends}, ${python3:Depends}
Description: Usable Configuration Management System
 cdist is a usable configuration management system.
 It adheres to the KISS principle and is being used in
 small up to enterprise grade environments. It has the
 following noteworthy features:
 .
  * shell scripting configuration language
  * access to all control structures (if, case, for, while)
  * idempotent target properties
  * zero-dependencies: target system need only /bin/sh and ssh
  * push-based distribution
  * highly-scalable
 .
 cdist is an alternative to other configuration management systems
 like cfengine, bcfg2, chef and puppet.

=== debian/rules ===
#!/usr/bin/make -f
export CHANGELOG_VERSION=$(shell dpkg-parsechangelog -SVersion)

%: cdist/version.py
	dh $@ --with python3 --buildsystem=python_distutils

# Upstream build system assumes git checkout. Since Debian source packages
# should be buildable from tarballs, we have to reimplement some of upstream
# build trickery.

cdist/version.py:
	echo "VERSION = '$(CHANGELOG_VERSION)'" > $@

build::
	$(MAKE) man
	find docs/man/ -name \*.1 -o -name \*.7 > debian/manpages

override_dh_auto_install:
	python3 setup.py install --root=debian/cdist --install-layout=deb
	find debian/cdist -name .gitignore -delete

override_dh_fixperms:
	dh_fixperms
	# Make lintian happy. If something have shebang, then `chmod +x'.
	find debian/cdist -type f -execdir \
		/bin/sh -c '(head -n1 {} | grep -qF "#!") && chmod +x {}' \;

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) clean
	rm -rf ./build
	find -name docbook-xsl.css -delete

=== debian/watch ===
version=3
opts="filenamemangle=s/.+\/(\d\S*)\.tar\.gz/cdist-$1\.tar\.gz/;s/pre/~pre/,uversionmangle=s/pre/~pre/" \
  https://github.com/telmich/cdist/tags .*/(\d\S*)\.tar\.gz

## cdist 4.0.0

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 # is the man page section (1 or 7). The first three lines of the input
 # (xml, DOCTYPE, head tags) are ignored, since the head tags contains
 # the title of the page and should not contain a href.
-CROSSLINK=sed --in-place '1,3!s/\([[:alnum:]_-]*\)(\([17]\))/<a href="..\/man\2\/\1.html">&<\/a>/g'
+CROSSLINK=sed -i '' '1,3!s/\([[:alnum:]_-]*\)(\([17]\))/<a href="..\/man\2\/\1.html">&<\/a>/g'
 helper=./bin/build-helper
 
 MANDIR=docs/man
@@ -35,7 +35,7 @@
 
 WEBSRCDIR=docs/web
 
-WEBDIR=$$HOME/www.nico.schottelius.org
+WEBDIR=$$HOME/vcs/www.nico.schottelius.org
 WEBBLOG=$(WEBDIR)/blog
 WEBBASE=$(WEBDIR)/software/cdist
 WEBPAGE=$(WEBBASE).mdwn
@@ -109,8 +109,8 @@
 
 man-latest-link: web-pub
 	# Fix ikiwiki, which does not like symlinks for pseudo security
-	ssh tee.schottelius.org \
-    	"cd /home/services/www/nico/www.nico.schottelius.org/www/software/cdist/man && rm -f latest && ln -sf "$(CHANGELOG_VERSION)" latest"
+	ssh staticweb.ungleich.ch \
+		"cd /home/services/www/nico/nico.schottelius.org/www/software/cdist/man/ && rm -f latest && ln -sf "$(CHANGELOG_VERSION)" latest"
 
 ################################################################################
 # Speeches
@@ -171,17 +171,6 @@
 
 
 ################################################################################
-# Release: Freecode
-#
-FREECODE_FILE=.lock-freecode
-
-$(FREECODE_FILE): $(CHANGELOG_FILE)
-	$(helper) freecode-release $(CHANGELOG_VERSION)
-	touch $@
-
-freecode-release: $(FREECODE_FILE)
-
-################################################################################
 # pypi
 #
 PYPI_FILE=.pypi-release
@@ -197,7 +186,7 @@
 ARCHLINUXTAR=cdist-$(CHANGELOG_VERSION)-1.src.tar.gz
 
 $(ARCHLINUXTAR): PKGBUILD
-	makepkg -c --source
+	umask 022; mkaurball
 
 PKGBUILD: PKGBUILD.in $(PYTHON_VERSION)
 	./PKGBUILD.in $(CHANGELOG_VERSION)
@@ -254,10 +243,7 @@
 
 # The pub is Nico's "push to all git remotes" way ("make pub")
 pub:
-	for remote in "" github sf; do \
-		echo "Pushing to $$remote"; \
-		git push --mirror $$remote; \
-	done
+	git push --mirror
 
 test:
 	$(helper) $@

=== debian/changelog ===
cdist (4.0.0-2) unstable; urgency=medium

  * patches/ensure-reproducible-build.patch: ensure deterministic file
    processing order.  Thanks to Chris Lamb <chris@chris-lamb.co.uk>.
    (Closes: #825406)
  * Call dh_fixperms after calling 'chmod +x' on files with shebang, since
    seems it is overzealos and causes executable manpage.

 -- Dmitry Bogatov <KAction@gnu.org>  Sat, 28 May 2016 01:25:09 +0300

cdist (4.0.0-1) unstable; urgency=medium

  * New upstream release
  * Refresh spelling patches
  * Improve machine-readability of debian/copyright
  * Disable building html documentation
  * Bump standards version to 3.9.8 (no changes needed)

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 15 May 2016 17:44:25 +0300

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  python3,
  xmlto,
  xsltproc,
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://www.nico.schottelius.org/software/cdist/
 Vcs-Browser: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git
 Vcs-Git: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git

=== debian/rules ===
--- 
+++ 
@@ -20,10 +20,10 @@
 	find debian/cdist -name .gitignore -delete
 
 override_dh_fixperms:
-	dh_fixperms
 	# Make lintian happy. If something have shebang, then `chmod +x'.
 	find debian/cdist -type f -execdir \
 		/bin/sh -c '(head -n1 {} | grep -qF "#!") && chmod +x {}' \;
+	dh_fixperms
 
 override_dh_auto_clean:
 	dh_auto_clean

## cdist 4.2.1

=== Makefile ===
--- 
+++ 
@@ -18,18 +18,9 @@
 #
 #
 
-A2XM=a2x -f manpage --no-xmllint -a encoding=UTF-8
-A2XH=a2x -f xhtml --no-xmllint -a encoding=UTF-8
-# Create cross-links in html man pages
-# We look for something like "cdist-type(7)" and make a href out of it
-# The first matching group is the man page name and the second group
-# is the man page section (1 or 7). The first three lines of the input
-# (xml, DOCTYPE, head tags) are ignored, since the head tags contains
-# the title of the page and should not contain a href.
-CROSSLINK=sed -i '' '1,3!s/\([[:alnum:]_-]*\)(\([17]\))/<a href="..\/man\2\/\1.html">&<\/a>/g'
 helper=./bin/build-helper
 
-MANDIR=docs/man
+DOCS_SRC_DIR=docs/src
 SPEECHDIR=docs/speeches
 TYPEDIR=cdist/conf/type
 
@@ -45,72 +36,78 @@
 
 PYTHON_VERSION=cdist/version.py
 
+SPHINXM=make -C $(DOCS_SRC_DIR) man
+SPHINXH=make -C $(DOCS_SRC_DIR) html
+SPHINXC=make -C $(DOCS_SRC_DIR) clean
 ################################################################################
 # Manpages
 #
-MAN1DSTDIR=$(MANDIR)/man1
-MAN7DSTDIR=$(MANDIR)/man7
+MAN1DSTDIR=$(DOCS_SRC_DIR)/man1
+MAN7DSTDIR=$(DOCS_SRC_DIR)/man7
 
 # Manpages #1: Types
-# Use shell / ls to get complete list - $(TYPEDIR)/*/man.text does not work
-MANTYPESRC=$(shell ls $(TYPEDIR)/*/man.text)
-
-# replace first path component
+# Use shell / ls to get complete list - $(TYPEDIR)/*/man.rst does not work
+# Using ls does not work if no file with given pattern exist, so use wildcard
+MANTYPESRC=$(wildcard $(TYPEDIR)/*/man.rst)
 MANTYPEPREFIX=$(subst $(TYPEDIR)/,$(MAN7DSTDIR)/cdist-type,$(MANTYPESRC))
-
-# replace man.text with .7 or .html
-MANTYPEMAN=$(subst /man.text,.7,$(MANTYPEPREFIX))
-MANTYPEHTML=$(subst /man.text,.html,$(MANTYPEPREFIX))
-MANTYPEALL=$(MANTYPEMAN) $(MANTYPEHTML)
-
-# Link manpage so A2XH does not create man.html but correct named file
-$(MAN7DSTDIR)/cdist-type%.text: $(TYPEDIR)/%/man.text
+MANTYPES=$(subst /man.rst,.rst,$(MANTYPEPREFIX))
+
+# Link manpage: do not create man.html but correct named file
+$(MAN7DSTDIR)/cdist-type%.rst: $(TYPEDIR)/%/man.rst
 	ln -sf "../../../$^" $@
 
 # Manpages #2: reference
-MANREF=$(MAN7DSTDIR)/cdist-reference.text
-MANREFSH=$(MANDIR)/cdist-reference.text.sh
-MANREFMAN=$(MANREF:.text=.7)
-MANREFHTML=$(MANREF:.text=.html)
-MANREFALL=$(MANREFMAN) $(MANREFHTML)
-
-$(MANREF): $(MANREFSH)
-	$(MANREFSH)
-
-# Manpages #3: static pages
-MAN1STATIC=$(shell ls $(MAN1DSTDIR)/*.text)
-MAN7STATIC=$(shell ls $(MAN7DSTDIR)/*.text)
-MANSTATICMAN=$(MAN1STATIC:.text=.1) $(MAN7STATIC:.text=.7)
-MANSTATICHTML=$(MAN1STATIC:.text=.html) $(MAN7STATIC:.text=.html)
-MANSTATICALL=$(MANSTATICMAN) $(MANSTATICHTML)
-
-# Manpages #4: generic part
-
-# Creating the type manpage
-%.1 %.7: %.text
-	$(A2XM) $^
-
-# Creating the type html page
-%.html: %.text
-	$(A2XH) $^
-	$(CROSSLINK) $@
-
-man: $(MANTYPEALL) $(MANREFALL) $(MANSTATICALL)
+DOCSREF=$(MAN7DSTDIR)/cdist-reference.rst
+DOCSREFSH=$(DOCS_SRC_DIR)/cdist-reference.rst.sh
+
+$(DOCSREF): $(DOCSREFSH)
+	$(DOCSREFSH)
+
+# Manpages #3: generic part
+man: $(MANTYPES) $(DOCSREF) $(PYTHON_VERSION)
+	$(SPHINXM)
+
+html: $(MANTYPES) $(DOCSREF) $(PYTHON_VERSION)
+	$(SPHINXH)
+
+docs: man html
+
+docs-clean:
+	$(SPHINXC)
 
 # Manpages #5: release part
 MANWEBDIR=$(WEBBASE)/man/$(CHANGELOG_VERSION)
-
-man-dist: man check-date
+HTMLBUILDDIR=docs/dist/html
+
+docs-dist: html
 	rm -rf "${MANWEBDIR}"
-	mkdir -p "${MANWEBDIR}/man1" "${MANWEBDIR}/man7"
-	cp ${MAN1DSTDIR}/*.html ${MAN1DSTDIR}/*.css ${MANWEBDIR}/man1
-	cp ${MAN7DSTDIR}/*.html ${MAN7DSTDIR}/*.css ${MANWEBDIR}/man7
+	mkdir -p "${MANWEBDIR}"
+	# mkdir -p "${MANWEBDIR}/man1" "${MANWEBDIR}/man7"
+	# cp ${MAN1DSTDIR}/*.html ${MAN1DSTDIR}/*.css ${MANWEBDIR}/man1
+	# cp ${MAN7DSTDIR}/*.html ${MAN7DSTDIR}/*.css ${MANWEBDIR}/man7
+	cp -R ${HTMLBUILDDIR}/* ${MANWEBDIR}
 	cd ${MANWEBDIR} && git add . && git commit -m "cdist manpages update: $(CHANGELOG_VERSION)" || true
 
 man-latest-link: web-pub
 	# Fix ikiwiki, which does not like symlinks for pseudo security
 	ssh staticweb.ungleich.ch \
 		"cd /home/services/www/nico/nico.schottelius.org/www/software/cdist/man/ && rm -f latest && ln -sf "$(CHANGELOG_VERSION)" latest"
+
+# Manpages: .cdist Types
+DOT_CDIST_PATH=${HOME}/.cdist
+DOTMAN7DSTDIR=$(MAN7DSTDIR)
+DOTTYPEDIR=$(DOT_CDIST_PATH)/type
+DOTMANTYPESRC=$(wildcard $(DOTTYPEDIR)/*/man.rst)
+DOTMANTYPEPREFIX=$(subst $(DOTTYPEDIR)/,$(DOTMAN7DSTDIR)/cdist-type,$(DOTMANTYPESRC))
+DOTMANTYPES=$(subst /man.rst,.rst,$(DOTMANTYPEPREFIX))
+
+# Link manpage: do not create man.html but correct named file
+$(DOTMAN7DSTDIR)/cdist-type%.rst: $(DOTTYPEDIR)/%/man.rst
+	ln -sf "$^" $@
+
+# Manpages #3: generic part
+dotman: $(DOTMANTYPES)
+	$(SPHINXM)
 
 ################################################################################
 # Speeches
@@ -151,7 +148,7 @@
 
 web-dist: web-blog web-doc
 
-web-pub: web-dist man-dist speeches-dist
+web-pub: web-dist docs-dist speeches-dist
 	cd "${WEBDIR}" && make pub
 
 web-release-all: man-latest-link
@@ -216,14 +213,12 @@
 #
 
 clean:
-	rm -f $(MAN7DSTDIR)/cdist-reference.text
-
-	find "$(MANDIR)" -mindepth 2 -type l \
-	    -o -name "*.1" \
-	    -o -name "*.7" \
-	    -o -name "*.html" \
-	    -o -name "*.xml" \
+	rm -f $(DOCS_SRC_DIR)/cdist-reference.rst
+
+	find "$(DOCS_SRC_DIR)" -mindepth 2 -type l \
 	| xargs rm -f
+
+	make -C $(DOCS_SRC_DIR) clean
 
 	find * -name __pycache__  | xargs rm -rf
 
@@ -234,6 +229,10 @@
 	rm -f MANIFEST PKGBUILD
 	rm -rf dist/
 
+	# Signed release
+	rm -f cdist-*.tar.gz
+	rm -f cdist-*.tar.gz.asc
+
 distclean: clean
 	rm -f cdist/version.py

=== docs/src/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = ../dist
# for cache, etc.
_BUILDDIR     = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
	$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don\'t have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(_BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  epub3      to make an epub3"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*
	rm -rf $(_BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/cdist-docs.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/cdist-docs.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/cdist-docs"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/cdist-docs"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3:
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b cman $(ALLSPHINXOPTS) $(BUILDDIR)/man
	mkdir -p $(BUILDDIR)/man/man1
	mkdir -p $(BUILDDIR)/man/man7
	mv -f $(BUILDDIR)/man/*.1 $(BUILDDIR)/man/man1/
	mv -f $(BUILDDIR)/man/*.7 $(BUILDDIR)/man/man7/
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

.PHONY: dummy
dummy:
	$(SPHINXBUILD) -b dummy $(ALLSPHINXOPTS) $(BUILDDIR)/dummy
	@echo
	@echo "Build finished. Dummy builder generates no files."

=== debian/changelog ===
cdist (4.2.1-1) unstable; urgency=medium

  * New upstream release
  * Refresh patch 'do-not-assume-git-checkout.patch'
  * Removed patches:
    - fix-more-spelling-errors.patch: applied upstream
    - disable-building-html.patch: no longer needed, since now upstream
      generates html via sphinx
    - ensure-reproducible-build.patch: applied upstream
  * New patch: fix-docs-man-Makefile.patch
  * Update debian/watch, check GPG signature
  * Update debian/rules:
      + take advantage of /usr/shake/dpkg/default.mk instead of manual
        invocation of 'dpkg-parsechangelog'
      + .gitignore file no longer installed, drop fix
      + remove no longer generated files from clean target
  * Use pybuild debhelper build system
  * Introduce new binary package 'cdist-doc', which contain html
    documentation.
  * Make 'debian/changelog' more accurate, mentioning GPLv3-only
    manpages.
  * Install doc-base control file.

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 19 Jun 2016 19:34:34 +0300

## cdist 4.2.2

=== debian/changelog ===
cdist (4.2.2-1) unstable; urgency=medium

  * New upstream release

 -- Dmitry Bogatov <KAction@gnu.org>  Tue, 26 Jul 2016 13:39:13 +0300

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,12 @@
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9),
- asciidoc,
  dh-python,
- docbook-utils,
- libxml2-utils,
+ dh-linktree,
  python3,
- xmlto,
- xsltproc,
+ python3-all,
+ python3-sphinx,
+ python3-sphinx-rtd-theme
 Standards-Version: 3.9.8
 Homepage: http://www.nico.schottelius.org/software/cdist/
 Vcs-Browser: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git
@@ -18,6 +17,7 @@
 Package: cdist
 Architecture: all
 Depends: python3 (>= 3.4), ${misc:Depends}, ${python3:Depends}
+Suggests: cdist-doc
 Description: Usable Configuration Management System
  cdist is a usable configuration management system.
  It adheres to the KISS principle and is being used in
@@ -33,3 +33,25 @@
  .
  cdist is an alternative to other configuration management systems
  like cfengine, bcfg2, chef and puppet.
+
+Package: cdist-doc
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}
+Description: Usable Configuration Management System (html documentation)
+ cdist is a usable configuration management system.
+ It adheres to the KISS principle and is being used in
+ small up to enterprise grade environments. It has the
+ following noteworthy features:
+ .
+  * shell scripting configuration language
+  * access to all control structures (if, case, for, while)
+  * idempotent target properties
+  * zero-dependencies: target system need only /bin/sh and ssh
+  * push-based distribution
+  * highly-scalable
+ .
+ cdist is an alternative to other configuration management systems
+ like cfengine, bcfg2, chef and puppet.
+ .
+ This package contains Sphinx-generated html documentation.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export PYBUILD_DESTDIR = debian/cdist

clean build: cdist/version.py
%:
	dh $@ --with python3,linktree --buildsystem=pybuild

# Upstream build system assumes git checkout. Since Debian source packages
# should be buildable from tarballs, we have to reimplement some of upstream
# build trickery.

cdist/version.py:
	echo "VERSION = '$(DEB_VERSION_UPSTREAM)'" > $@

override_dh_install:
	dh_install -X objects.inv -X _sources/

override_dh_auto_build:
	$(MAKE) man html

# If something have shebang, then `chmod +x'.
override_dh_fixperms:
	dh_fixperms
	find debian/cdist -type f -execdir \
	    /bin/sh -c '(head -n1 {} | grep -qF "#!") && chmod +x {}' \;

override_dh_auto_clean: cdist/version.py
	$(MAKE) clean
	rm -rf ./build
	dh_auto_clean

## cdist 4.3.1

=== debian/changelog ===
cdist (4.3.1-2build1) yakkety; urgency=medium

  * No-change rebuild against current sphinx.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 06 Oct 2016 17:58:32 +0000

cdist (4.3.1-2) unstable; urgency=medium

  * Rebuild for unstable to get latest sphinx dependency (Closes: #837312)
  * Force `sphinx-build' use Python3 (Closes: #837311)

 -- Dmitry Bogatov <KAction@gnu.org>  Sat, 10 Sep 2016 16:33:38 +0300

cdist (4.3.1-1) unstable; urgency=medium

  * New upstream release
  * Update `debian/copyright' -- GPLv3-only issue is almost solved.

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 21 Aug 2016 23:36:29 +0300

cdist (4.2.2-2) unstable; urgency=medium

  * Take advantage of 'dh_sphinxdoc'. It reduce number of paths to
    mention in cdist-doc.linktrees
  * Fix `dpkg-buildpackage -A' build
  * Install bash completion

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 31 Jul 2016 11:53:18 +0300

## cdist 4.3.2

=== debian/changelog ===
cdist (4.3.2-1) unstable; urgency=medium

  * New upstream release

 -- Dmitry Bogatov <KAction@gnu.org>  Fri, 14 Oct 2016 09:45:05 +0300

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,15 @@
 Maintainer: Dmitry Bogatov <KAction@gnu.org>
 Section: admin
 Priority: optional
+Build-Conflicts: python-sphinx
 Build-Depends: debhelper (>= 9),
  dh-python,
  dh-linktree,
  python3,
  python3-all,
  python3-sphinx,
- python3-sphinx-rtd-theme
+ python3-sphinx-rtd-theme,
+ bash-completion
 Standards-Version: 3.9.8
 Homepage: http://www.nico.schottelius.org/software/cdist/
 Vcs-Browser: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git
@@ -37,7 +39,7 @@
 Package: cdist-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: Usable Configuration Management System (html documentation)
  cdist is a usable configuration management system.
  It adheres to the KISS principle and is being used in

## cdist 4.4.0

=== debian/changelog ===
cdist (4.4.0-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright
  * Make dh-linktree generate weak dependency on sphinx, not strong.

    + This change simplify upgrades of sphinx at expense of increased risk
      of dangling symbolic links in cdist generated documentation.

    + Requested by: Dmitry Shachnev <mitya57@debian.org>

 -- Dmitry Bogatov <KAction@gnu.org>  Mon, 12 Dec 2016 12:58:21 +0300

## cdist 4.4.1

=== Makefile ===
--- 
+++ 
@@ -246,3 +246,6 @@
 
 test:
 	$(helper) $@
+
+pep8:
+	$(helper) $@

=== debian/changelog ===
cdist (4.4.1-1) unstable; urgency=medium

  * New upstream release

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 18 Dec 2016 12:54:12 +0300

=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,10 @@
 include /usr/share/dpkg/default.mk
 export PYBUILD_DESTDIR = debian/cdist
 
-clean build: cdist/version.py
+clean build-arch build-indep: cdist/version.py
 %:
-	dh $@ --with python3,linktree --buildsystem=pybuild
+	dh $@ --with python3,linktree,sphinxdoc,bash_completion \
+	    --buildsystem=pybuild
 
 # Upstream build system assumes git checkout. Since Debian source packages
 # should be buildable from tarballs, we have to reimplement some of upstream
@@ -12,9 +13,6 @@
 
 cdist/version.py:
 	echo "VERSION = '$(DEB_VERSION_UPSTREAM)'" > $@
-
-override_dh_install:
-	dh_install -X objects.inv -X _sources/
 
 override_dh_auto_build:
 	$(MAKE) man html

## cdist 4.8.4

=== debian/changelog ===
cdist (4.8.4-1) unstable; urgency=medium

  * New upstream release
  * Drop patch-fix-spelling-errors-in-manpages.patch (applied upstream)
  * Update standards version to 4.1.4 (no changes needed)
  * Explicitly add /sbin:/usr/sbin to PATH when executing remote code.
    Without this change some types fail when ssh server is dropbear, not
    openssh.

 -- Dmitry Bogatov <KAction@gnu.org>  Sat, 21 Apr 2018 01:07:22 +0300

cdist (4.8.3-1) unstable; urgency=medium

  * New upstream release
  * Refresh 'do-not-assume-git-checkout.patch'
  * Update debian/copyright
  * Use secure protocol when referring to copyright format uri.
  * Update standards version to 4.1.3 (no changes needed)
  * Update debhelper version to 11 (no changes needed)
  * Install examples of alternative scp/ssh commands
  * Update Vcs-* fields in debian/control.
  * Ensure that code in debian/rules, that sets executable bit on scripts
    associated with types, does not process manpages. Otherwise, some
    manpages could become executable.
  * Fix build from Git working tree by recreating empty docs/src/man7
    directory.

 -- Dmitry Bogatov <KAction@gnu.org>  Thu, 05 Apr 2018 20:34:51 +0300

## cdist 4.9.0

=== debian/changelog ===
cdist (4.9.0-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright

 -- Dmitry Bogatov <KAction@gnu.org>  Thu, 17 May 2018 23:54:24 +0300

## cdist 4.9.1

=== debian/changelog ===
cdist (4.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 03 Jun 2018 13:20:43 +0300

=== debian/rules ===
--- 
+++ 
@@ -15,12 +15,25 @@
 	echo "VERSION = '$(DEB_VERSION_UPSTREAM)'" > $@
 
 override_dh_auto_build:
+	# This directory is lost during
+	#
+	# upstream git -> tarball -> git-buildpackage
+	#
+	# process, since .gitignore files are excluded by
+	# git-archive(1) and tarballs can store empty directories,
+	# but git can not.
+	#
+	# Without this directory, build from git repository fails.
+	mkdir -p docs/src/man7
 	$(MAKE) man html
 
-# If something have shebang, then `chmod +x'.
+# If something has shebang, then `chmod +x'. But it is important to
+# search only among scripts, since some manpages trigger false-positive
+# (compressed manpages are considered to have single line by head(1),
+# and somewhere in that line #! sometimes occurs)
 override_dh_fixperms:
 	dh_fixperms
-	find debian/cdist -type f -execdir \
+	find debian/cdist/usr/lib/python3 -type f -execdir \
 	    /bin/sh -c '(head -n1 {} | grep -qF "#!") && chmod +x {}' \;
 
 override_dh_auto_clean: cdist/version.py

## cdist 4.10.0

=== debian/changelog ===
cdist (4.10.0-1) unstable; urgency=medium

  * New upstream release

 -- Dmitry Bogatov <KAction@gnu.org>  Tue, 19 Jun 2018 10:50:33 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Build-Conflicts: python-sphinx
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11~),
  dh-python,
  dh-linktree,
  python3,
@@ -11,10 +11,10 @@
  python3-sphinx,
  python3-sphinx-rtd-theme,
  bash-completion
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: http://www.nico.schottelius.org/software/cdist/
-Vcs-Browser: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git
-Vcs-Git: https://anonscm.debian.org/cgit/users/kaction-guest/cdist.git
+Vcs-Browser: https://salsa.debian.org/iu-guest/cdist
+Vcs-Git: https://salsa.debian.org/iu-guest/cdist.git
 
 Package: cdist
 Architecture: all

## cdist 4.10.2

=== Makefile ===
--- 
+++ 
@@ -198,7 +198,7 @@
 # Release
 #
 
-$(PYTHON_VERSION): .git/refs/heads/master
+$(PYTHON_VERSION) version: .git/refs/heads/master
 	$(helper) version
 
 # Code that is better handled in a shell script
@@ -247,5 +247,8 @@
 test:
 	$(helper) $@
 
+test-remote:
+	$(helper) $@
+
 pep8:
 	$(helper) $@

=== docs/src/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 # User-friendly check for sphinx-build
 ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
-	$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don\'t have Sphinx installed, grab it from http://sphinx-doc.org/)
+    $(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don\'t have Sphinx installed, grab it from http://sphinx-doc.org/)
 endif
 
 # Internal variables.

=== debian/changelog ===
cdist (4.10.2-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright
  * Bump standards version to 4.2.1 (no changes needed)
  * Remove installation instruction from binary package
  * Add GitLab CI configuration file
  * Add autopkgtest, checking that installation is correct

 -- Dmitry Bogatov <KAction@gnu.org>  Sun, 09 Sep 2018 13:01:03 +0300

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  python3-sphinx,
  python3-sphinx-rtd-theme,
  bash-completion
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: http://www.nico.schottelius.org/software/cdist/
 Vcs-Browser: https://salsa.debian.org/iu-guest/cdist
 Vcs-Git: https://salsa.debian.org/iu-guest/cdist.git

=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,12 @@
 	mkdir -p docs/src/man7
 	$(MAKE) man html
 
+# This file contains instruction how to install cdist system-wide. It
+# gets installed in wrong place and actually redundant.
+override_dh_auto_install:
+	dh_auto_install
+	rm -f debian/cdist/usr/lib/python3/dist-packages/cdist/conf/README
+
 # If something has shebang, then `chmod +x'. But it is important to
 # search only among scripts, since some manpages trigger false-positive
 # (compressed manpages are considered to have single line by head(1),

## cdist 4.10.3

=== debian/changelog ===
cdist (4.10.3-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright
  * Adjust code, removing redundant REAME to multiple Python version
  * Replace duplicate files with symlinks using jdupes(1)

 -- Dmitry Bogatov <KAction@gnu.org>  Wed, 26 Sep 2018 15:09:52 +0300

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,8 @@
  python3-all,
  python3-sphinx,
  python3-sphinx-rtd-theme,
- bash-completion
+ bash-completion,
+ jdupes,
 Standards-Version: 4.2.1
 Homepage: http://www.nico.schottelius.org/software/cdist/
 Vcs-Browser: https://salsa.debian.org/iu-guest/cdist

## cdist 4.10.4

=== debian/changelog ===
cdist (4.10.4-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright
  * Build-depend on `debhelper-compat' (obsoletes `debian/compat')
  * Update Vcs-* fields in debian/control (package moved into debian/ group)

 -- Dmitry Bogatov <KAction@debian.org>  Mon, 05 Nov 2018 23:31:45 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: cdist
-Maintainer: Dmitry Bogatov <KAction@gnu.org>
+Maintainer: Dmitry Bogatov <KAction@debian.org>
 Section: admin
 Priority: optional
 Build-Conflicts: python-sphinx
-Build-Depends: debhelper (>= 11~),
+Build-Depends:
+ debhelper-compat (= 11),
  dh-python,
  dh-linktree,
  python3,
@@ -14,8 +15,8 @@
  jdupes,
 Standards-Version: 4.2.1
 Homepage: http://www.nico.schottelius.org/software/cdist/
-Vcs-Browser: https://salsa.debian.org/iu-guest/cdist
-Vcs-Git: https://salsa.debian.org/iu-guest/cdist.git
+Vcs-Browser: https://salsa.debian.org/debian/cdist
+Vcs-Git: https://salsa.debian.org/debian/cdist.git
 
 Package: cdist
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,11 @@
 # gets installed in wrong place and actually redundant.
 override_dh_auto_install:
 	dh_auto_install
-	rm -f debian/cdist/usr/lib/python3/dist-packages/cdist/conf/README
+	find debian/cdist/usr/lib -name 'README' -delete
+
+override_dh_install:
+	dh_install
+	jdupes --linksoft --recurse debian/cdist-doc
 
 # If something has shebang, then `chmod +x'. But it is important to
 # search only among scripts, since some manpages trigger false-positive

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
     https://github.com/ungleich/cdist/releases \
     /ungleich/cdist/releases/download/(\d[\d.]*)/cdist-\d[\d.]*\.tar\.gz

## cdist 4.10.5

=== debian/changelog ===
cdist (4.10.5-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright
  * Add Built-Using field to binary package `cdist-doc'
  * Refresh patches

 -- Dmitry Bogatov <KAction@debian.org>  Mon, 24 Dec 2018 16:23:13 +0000

=== debian/control ===
--- 
+++ 
@@ -41,6 +41,7 @@
 Package: cdist-doc
 Section: doc
 Architecture: all
+Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: Usable Configuration Management System (html documentation)
  cdist is a usable configuration management system.

## cdist 4.10.6

=== Makefile ===
--- 
+++ 
@@ -39,6 +39,11 @@
 SPHINXM=make -C $(DOCS_SRC_DIR) man
 SPHINXH=make -C $(DOCS_SRC_DIR) html
 SPHINXC=make -C $(DOCS_SRC_DIR) clean
+
+SHELLCHECKCMD=shellcheck -s sh -f gcc -x
+# Skip SC2154 for variables starting with __ since such variables are cdist
+# environment variables.
+SHELLCHECK_SKIP=grep -v ': __.*is referenced but not assigned.*\[SC2154\]'
 ################################################################################
 # Manpages
 #
@@ -54,6 +59,7 @@
 
 # Link manpage: do not create man.html but correct named file
 $(MAN7DSTDIR)/cdist-type%.rst: $(TYPEDIR)/%/man.rst
+	mkdir -p $(MAN7DSTDIR)
 	ln -sf "../../../$^" $@
 
 # Manpages #2: reference
@@ -252,3 +258,29 @@
 
 pep8:
 	$(helper) $@
+
+shellcheck-global-explorers:
+	@find cdist/conf/explorer -type f -exec $(SHELLCHECKCMD) {} + | $(SHELLCHECK_SKIP) || exit 0
+
+shellcheck-type-explorers:
+	@find cdist/conf/type -type f -path "*/explorer/*" -exec $(SHELLCHECKCMD) {} + | $(SHELLCHECK_SKIP) || exit 0
+
+shellcheck-manifests:
+	@find cdist/conf/type -type f -name manifest -exec $(SHELLCHECKCMD) {} + | $(SHELLCHECK_SKIP) || exit 0
+
+shellcheck-local-gencodes:
+	@find cdist/conf/type -type f -name gencode-local -exec $(SHELLCHECKCMD) {} + | $(SHELLCHECK_SKIP) || exit 0
+
+shellcheck-remote-gencodes:
+	@find cdist/conf/type -type f -name gencode-remote -exec $(SHELLCHECKCMD) {} + | $(SHELLCHECK_SKIP) || exit 0
+
+shellcheck-gencodes: shellcheck-local-gencodes shellcheck-remote-gencodes
+
+shellcheck-types: shellcheck-type-explorers shellcheck-manifests shellcheck-gencodes
+
+shellcheck: shellcheck-global-explorers shellcheck-types
+
+shellcheck-type-files:
+	@find cdist/conf/type -type f -path "*/files/*" -exec $(SHELLCHECKCMD) {} + | $(SHELLCHECK_SKIP) || exit 0
+
+shellcheck-with-files: shellcheck shellcheck-type-files

=== debian/changelog ===
cdist (4.10.6-1) unstable; urgency=medium

  * New upstream release
  * Use secure URI in Homepage field.

 -- Dmitry Bogatov <KAction@debian.org>  Sat, 16 Feb 2019 21:12:00 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  bash-completion,
  jdupes,
 Standards-Version: 4.2.1
-Homepage: http://www.nico.schottelius.org/software/cdist/
+Homepage: https://www.nico.schottelius.org/software/cdist/
 Vcs-Browser: https://salsa.debian.org/debian/cdist
 Vcs-Git: https://salsa.debian.org/debian/cdist.git
